        /* Copyright (c) 2007 by IBM Corporation */

dojo.provide("zero.form.widget.field.NumberFieldMixin");

dojo.require("zero.form.common.components.statics");
dojo.require("zero.form.widget.field.TextFieldValidationMixin");
dojo.require("zero.form.widget.field.properties.WidthPropertyMixin");
dojo.require("zero.form.widget.field.properties.RangePropertyHandlerMixin");

dojo.declare("zero.form.widget.field.NumberFieldMixin", 
    [zero.form.widget.field.TextFieldValidationMixin], 
	{
		widthProperty: "",
        maxValue: '',
        minValue: '',
		numberType: TYPE_PROPERTY_DECIMAL,

		getHandlers: function()
		{
			return [new zero.form.widget.field.properties.WidthPropertyMixin(),
					new zero.form.widget.field.properties.RangePropertyHandlerMixin()];
		},
		
		startup: function()
	   	{
            zero.form.widget.field.NumberFieldMixin.superclass.startup.apply(this, arguments);
			this.setNumberType(this.numberType);
	   	},
		
		setNumberType: function(type)
		{
			this.numberType = type;
			this.constraints.places = (type == TYPE_PROPERTY_INTEGER)?0:undefined;
		},
		
		getNumberType: function()
		{
			return this.numberType;
		},

		toNumber: function(value)
		{
			if(value === "")
				return "";
			value = (value)?value:"0";
			return (this.constraints.places == 0)? parseInt(value) : parseFloat(value);
		},
		
        getValue: function()
	    {
			var val = zero.form.widget.field.NumberFieldMixin.superclass.getValue.apply(this, arguments);
	   	 	return this.toNumber(val);
	    },
	   
	    setValue: function(val)
	    {
            if(val === undefined || val === null)
				val = 0;
			if(isNaN(val))
				val = "";
			this._settingValue = true;
	   		arguments[0] = ""+val;
			zero.form.widget.field.NumberFieldMixin.superclass.setValue.apply(this, arguments);
	    },
        
		setAdditionalProperties: function(pJson)
		{
			this.widthProperty = (pJson.width === undefined) ? "" : pJson.width;
			// empty string is the default min/max value - means unbounded			
			this.maxValue = (pJson.max === undefined) ? "" : pJson.max;
        	this.minValue = (pJson.min === undefined) ? "" : pJson.min;
        	this.numberType = (pJson.numberType === undefined) ? TYPE_PROPERTY_DECIMAL : pJson.numberType;
		},
		
		getAdditionalProperties: function(pJson)
		{
			if (this.widthProperty !== undefined && this.widthProperty !== "") 
			{
				pJson.width = this.widthProperty;
			}
			
			// don't set min/max if it is not defined
			if (this.maxValue !== undefined && this.maxValue !== "") 
			{
				pJson.max = this.maxValue;
			}
			if (this.minValue !== undefined && this.minValue !== "") 
			{
				pJson.min = this.minValue;
			}
			if (this.numberType !== undefined && this.numberType !== "") 
			{
				pJson.numberType = this.numberType;
			}
		},
		
		getWidth: function()
		{
			return this.widthProperty;
		},
		
		setWidth: function(pWidth)
		{
			this.widthProperty = pWidth;
		},
		
		getMax: function()
		{
			return this.maxValue;
		},
		
		setMax: function(pMax)
		{
			this.maxValue = pMax;
		},

		getMin: function()
		{
			return this.minValue;
		},
		
		setMin: function(pMin)
		{
			this.minValue = pMin;
		}
});
